-- Broker_Wraps by Lastrite
-- All credits to Astromech, author of Carousel, who I stole most of the code from...

--------------------------------------------------
--------------------------------------------------
local BWA = setmetatable({}, {__tostring = function() return "BWA" end})
_G.BWA = BWA
LibStub("AceConsole-3.0"):Embed(BWA)
local LDB = LibStub("LibDataBroker-1.1")
------------------
BWA.WrapcontrolA = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_WrapcontrolA", {
	type = "data source",
---	icon = "Interface\\Icons\\INV_Gizmo_02.png",
	label = "WrapcontrolA"
})

function BWA.WrapcontrolA:OnTooltipShow()
	GameTooltip:AddLine("Broker_WrapcontrolA")
	GameTooltip:AddLine("|cffeeeeeeClick to cycle|r")
end

function BWA.WrapcontrolA.OnClick(self, button)
	BWA:CycleRight()
end
------------------
BWA.WrapA = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_WrapA", {
	type = "data source",
	icon = nil,
	text = "..." ,
	tooltiptext = nil,
	OnTooltipShow = nil,
	OnClick = nil,
	OnEnter = nil,
	OnLeave = nil

})
----------------------------------------------------
----------------------------------------------------

local objects = {}
local objectPlace = {}
local activeName, objectOrder, db, objectDBs
BWA.objects = objects

local eventFrame = CreateFrame"Frame"
eventFrame:RegisterEvent"PLAYER_LOGIN"
eventFrame:SetScript("OnEvent", function(self, event, ...)
	BWA[event](BWA, event, ...)
end)

BWA.defaults = {
	profile = {
		textColor = {1, 1, 1, 1},
		labelColor = {1, 1, 0, 1},
		objectOrder = {},
		objectDBs = {
			["*"] = {
				enabled = true,
				showLabel = true,
				showText = true,
				showIcon = true,
				autoresize = false,
				autoshow = false,
			}
		},
	},
}

function BWA:PLAYER_LOGIN()
	BWA.PLAYER_LOGIN = nil
	BWA.db = LibStub("AceDB-3.0"):New("Broker_WrapsDB", BWA.defaults, "Default")
	BWA.db.RegisterCallback(BWA, "OnProfileChanged", "OnProfileChanged")
	BWA.db.RegisterCallback(BWA, "OnProfileReset", "OnProfileChanged")
	BWA.db.RegisterCallback(BWA, "OnProfileCopied", "OnProfileChanged")
	BWA:RegisterOptions()
	BWA:SetupObjects()
	BWA:OnProfileChanged(nil, BWA.db)
end

function BWA:OnProfileChanged(_, new)
	db = new.profile
	objectDBs = db.objectDBs
	BWA:UpdateColors()
	BWA:UpdateObjectOrder()
	BWA:CycleRight()
end

local textColor, labelColor
function BWA:UpdateColors()
	local t, l = db.textColor, db.labelColor
	textColor = string.format("ff%02x%02x%02x", t[1]*255, t[2]*255, t[3]*255)
	labelColor = string.format("ff%02x%02x%02x", l[1]*255, l[2]*255, l[3]*255)
end

---------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------

function BWA:SetupObjects()
	BWA.SetupObjects = nil
	for name, obj in LDB:DataObjectIterator() do
		BWA:DataObjectCreated(nil, name, obj)
	end
	LDB.RegisterCallback(BWA, "LibDataBroker_DataObjectCreated", "DataObjectCreated")
	LDB.RegisterCallback(BWA, "LibDataBroker_AttributeChanged", "UpdateText")
end

function BWA:DataObjectCreated(_, name, obj)
	objects[name] = obj
	if objectOrder and not objectPlace[name] and BWA.db.profile.objectDBs[name].enabled then
		tinsert(objectOrder, name)
		objectPlace[name] = #objectOrder
	end
	BWA:RegisterObjectOptions(name)
end

function BWA:UpdateObjectOrder()
	objectOrder = db.objectOrder
	for k,v in pairs(objectPlace) do
		objectPlace[k] = nil
	end
	for k,v in pairs(objectOrder) do
		objectPlace[v] = k
	end
	for k,v in pairs(objects) do
		if not objectPlace[k] and db.objectDBs[k].enabled then
			tinsert(objectOrder, k)
			objectPlace[k] = #objectOrder
		end
	end
	activeName = nil
	BWA:ReorderOrderOptions()
end



function BWA:CycleRight()
	local offset = (activeName and objectPlace[activeName]) or 0
	local max = #objectOrder
	local index, name
	for i=1,max do
		index = i + offset
		index = index > max and index - max or index
		name = objectOrder[index]
		if objects[name] and objectDBs[name].enabled then
			BWA:SetActiveObject(name)
			return
		end
	end
	BWA:SetActiveObject(nil)
end

function BWA:CycleLeft()
	local offset = (activeName and objectPlace[activeName]) or 2
	local max = #objectOrder
	local index, name
	for i=1,max do
		index = offset - i
		index = index <= 0 and max + index or index
		name = objectOrder[index]
		if objects[name] and objectDBs[name].enabled then
			BWA:SetActiveObject(name)
			return
		end
	end
	BWA:SetActiveObject(nil)
end

function BWA:SetActiveObject(name)
	activeName = name
	BWA.activeName = name
	BWA:UpdateObject()
end

function BWA:UpdateObject()
	if not activeName then
		BWA.WrapA.text = format("|c%sWrapA|r", labelColor)
	else
		BWA:UpdateText(nil, activeName)
	end
end

function BWA:UpdateText(_, name)
	if activeName ~= name then 
		if objectPlace[name] and db.objectDBs[name].enabled and db.objectDBs[name].autoshow then
			BWA:SetActiveObject(name)
		end
		return
	end
	local active = objects[name]
	if active.type == "launcher" or active.launcher then
		if objectDBs[name].showText then
			local addonName, title = GetAddOnInfo(active.tocname or name)
			BWA.WrapA.text = format("|c%s%s|r", textColor, title or addonName or name)
		end
	else
---
	BWA.WrapA.label = nil
	BWA.WrapA.icon = nil
	BWA.WrapA.tooltiptext = nil
	BWA.WrapA.OnTooltipShow = nil
	BWA.WrapA.OnClick = nil
	BWA.WrapA.OnEnter = nil
	BWA.WrapA.OnLeave = nil
	if active.label then 
		BWA.WrapcontrolA.label = active.label
		BWA.WrapcontrolA.text = " "
		else
		local addonName, title = GetAddOnInfo(active.tocname or name)
		BWA.WrapcontrolA.label = title or addonName or name
		BWA.WrapcontrolA.text = " "
	end
	if active.icon then BWA.WrapcontrolA.icon = active.icon else BWA.WrapcontrolA.icon = "Interface\\Icons\\INV_Gizmo_02.png" end
	if active.tooltiptext then BWA.WrapA.tooltiptext = active.tooltiptext end
	if active.OnTooltipShow then BWA.WrapA.OnTooltipShow = active.OnTooltipShow  end
	if active.OnClick then BWA.WrapA.OnClick = active.OnClick end
	if active.OnEnter then BWA.WrapA.OnEnter = active.OnEnter end
	if active.OnLeave then BWA.WrapA.OnLeave = active.OnLeave end
---
		if objectDBs[name].showText then
			local tr, tg, tb = unpack(db.textColor)
			if active.value and active.suffix then
				BWA.WrapA.text = format("|c%s%s|r|c%s%s|r", 
					textColor, tostring(active.value), labelColor, active.suffix or "")
			else
				BWA.WrapA.text = format("|c%s%s|r", textColor, active.text or "")
			end
		else
			BWA.WrapA.text = nil
		end

	end
end
	
------------------------------------------------------------
------------------------------------------------------------

function BWA:GetObjectOrder(name)
	return objectPlace[name]
end

function BWA:OrderObjectAdd(name)
	if objectPlace[name] then return end
	local index = #objectOrder+1
	objectOrder[index] = name
	objectPlace[name] = index
end

function BWA:OrderObjectRemove(name)
	if not objectPlace[name] then return end
	if name == activeName then BWA:CycleRight() end
	local index = objectPlace[name]
	table.remove(objectOrder, index)
	objectPlace[name] = nil
	for k,v in pairs(objectOrder) do
		objectPlace[v] = k
	end
end

function BWA:OrderObjectDown(name)
	if not objectPlace[name] then return end
	local index = objectPlace[name]
	local max = #objectOrder
	if max == index then
		objectOrder[max] = nil
		table.insert(objectOrder, 1, name)
		for k,v in pairs(objectOrder) do
			objectPlace[v] = k
		end
	else
		local a, b = objectOrder[index], objectOrder[index+1]
		objectOrder[index+1], objectOrder[index] = a, b
		objectPlace[a], objectPlace[b] = index+1, index
	end
end

function BWA:OrderObjectUp(name)
	if not objectPlace[name] then return end
	local index = objectPlace[name]
	if 1 == index then
		table.remove(objectOrder, 1)
		table.insert(objectOrder, name)
		for k,v in pairs(objectOrder) do
			objectPlace[v] = k
		end
	else
		local a, b = objectOrder[index], objectOrder[index-1]
		objectOrder[index-1], objectOrder[index] = a, b
		objectPlace[a], objectPlace[b] = index-1, index
	end
end

function BWA:IterateOrderedObjects()
	return pairs(objectPlace)
end
	